config/routes.rb
Rails.application.routes.draw do
  resources :actor_histories
  resources :movie_watchlists
  resources :actor_fanlists
  resources :actor_lists
  resources :movie_histories
  resources :ratings
  resources :movie_lists
  resources :seasons
  resources :age_ratings
  resources :cast_members
  resources :actors
  resources :movie_tag_counts
  resources :movie_tags
  resources :countries
  resources :genres
  devise_for :users
  resources :movies
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/movie_tag.rb
class MovieTag < ApplicationRecord
  has_many :movie_tag_counts
  has_many :movies, through: :movie_tag_counts

  validates_length_of :name, maximum: 50, allow_blank: false

end

app/controllers/movie_tags_controller.rb
class MovieTagsController < ApplicationController
  before_action :set_movie_tag, only: [:show, :edit, :update, :destroy]

  # GET /movie_tags
  # GET /movie_tags.json
  def index
    @movie_tags = MovieTag.all
  end

  # GET /movie_tags/1
  # GET /movie_tags/1.json
  def show
  end

  # GET /movie_tags/new
  def new
    @movie_tag = MovieTag.new
  end

  # GET /movie_tags/1/edit
  def edit
  end

  # POST /movie_tags
  # POST /movie_tags.json
  def create
    @movie_tag = MovieTag.new(movie_tag_params)

    respond_to do |format|
      if @movie_tag.save
        format.html { redirect_to @movie_tag, notice: 'Movie tag was successfully created.' }
        format.json { render :show, status: :created, location: @movie_tag }
      else
        format.html { render :new }
        format.json { render json: @movie_tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /movie_tags/1
  # PATCH/PUT /movie_tags/1.json
  def update
    respond_to do |format|
      if @movie_tag.update(movie_tag_params)
        format.html { redirect_to @movie_tag, notice: 'Movie tag was successfully updated.' }
        format.json { render :show, status: :ok, location: @movie_tag }
      else
        format.html { render :edit }
        format.json { render json: @movie_tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /movie_tags/1
  # DELETE /movie_tags/1.json
  def destroy
    @movie_tag.destroy
    respond_to do |format|
      format.html { redirect_to movie_tags_url, notice: 'Movie tag was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_movie_tag
      @movie_tag = MovieTag.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def movie_tag_params
      params.require(:movie_tag).permit(:name)
    end
end

app/helpers/movie_tags_helper.rb
module MovieTagsHelper
end

app/views/movie_tags/_form.html.erb
<%= form_for(movie_tag) do |f| %>
  <% if movie_tag.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(movie_tag.errors.count, "error") %> prohibited this movie_tag from being saved:</h2>

      <ul>
      <% movie_tag.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/movie_tags/edit.html.erb
<h1>Editing Movie Tag</h1>

<%= render 'form', movie_tag: @movie_tag %>

<%= link_to 'Show', @movie_tag %> |
<%= link_to 'Back', movie_tags_path %>

app/views/movie_tags/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Movie Tags</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @movie_tags.each do |movie_tag| %>
      <tr>
        <td><%= movie_tag.name %></td>
        <td><%= link_to 'Show', movie_tag %></td>
        <td><%= link_to 'Edit', edit_movie_tag_path(movie_tag) %></td>
        <td><%= link_to 'Destroy', movie_tag, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Movie Tag', new_movie_tag_path %>

app/views/movie_tags/new.html.erb
<h1>New Movie Tag</h1>

<%= render 'form', movie_tag: @movie_tag %>

<%= link_to 'Back', movie_tags_path %>

app/views/movie_tags/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @movie_tag.name %>
</p>

<%= link_to 'Edit', edit_movie_tag_path(@movie_tag) %> |
<%= link_to 'Back', movie_tags_path %>